[![Latest Version on NPM](https://img.shields.io/npm/v/vue-cal.svg)](https://npmjs.com/package/vue-cal)
[![Software License](https://img.shields.io/badge/license-MIT-brightgreen.svg)](LICENSE.md)
[![npm](https://img.shields.io/npm/dt/vue-cal.svg)](https://www.npmjs.com/package/vue-cal)
[![npm](https://img.shields.io/npm/dw/vue-cal.svg)](https://www.npmjs.com/package/vue-cal)
[![JavaScript Style Guide](https://img.shields.io/badge/code_style-standard-brightgreen.svg)](https://standardjs.com)

<img width="1057" alt="vue-cal-5" src="https://github.com/user-attachments/assets/70502565-f03e-47bd-b217-9adf9ce9e561" />

# Vue Cal v5 - A Flexible and Beautiful Vue 3 Calendar 📅✨

Vue Cal is your ultimate Vue 3 calendar solution! Packed with powerful features, it's **highly customizable**, **elegant**, and designed to fit all kinds of scheduling needs. Whether you’re building a personal planner, a booking system, or a productivity tool, Vue Cal is here to make your job easier and more enjoyable.

---

## 🌟 Features at a Glance

- 🔄 **Fully Responsive**: Beautiful on any screen size.
- 🎨 **Customizable**: Tailor colors, any kind of slots, and views to your needs. Attach all DOM events that you want.
- 🗓️ **Multiple Views**: Choose between day, week, and month views (and more!).
- 📌 **Event Management**: Add, edit, drag-and-drop, and resize events with ease.
- ⚡️ **Lightweight & Fast**: Built with performance in mind.

___

## 🚀 v5 is Here! A New Era Begins

The long-awaited v5 is now officially released! This version has been rebuilt from the ground up, bringing powerful new features, performance improvements, and a solid foundation for future growth.

Every line of code has been carefully crafted to maintain the highest standards, ensuring reliability, flexibility, and ease of use for our community.

### 💡 Your Support Fuels the Future

🌟 Whether you’re using this project for a hobby, a commercial product, or to explore new technologies, your support makes a huge difference! Sponsorships help us continue improving, refining documentation, and ensuring long-term stability. 🚀

Let me know if you’d like any tweaks! 🎉

---

## 🌍 Demo & Documentation

Experience Vue Cal in action or dive into the docs for setup instructions and API details.

### New V5! 🚀
> [**Demo & Documentation**](https://antoniandre.github.io/vue-cal)

### V4 (Stable)

> [**V4 Demo & Documentation**](https://antoniandre.github.io/vue-cal-v4)

> [**V4 Repo**](https://antoniandre.github.io/vue-cal-v4)

---

## 📦 Installation

Install the latest prerelease of Vue Cal V5 with your favorite package manager:

```bash
npm i vue-cal@next
```

---

## 💡 Why Choose Vue Cal?

With over **1.2k stars** on GitHub and trusted by developers around the globe, Vue Cal is more than just a library — it’s a **community-driven project** committed to providing excellence.

---

## 🤝 Support the Project

### **Why Sponsor?** 💛

Vue Cal is a labor of love, built and maintained by passionate developers to save you time and effort. Your support helps us:

- **Add new features** you’ve been asking for.
- **Fix bugs** quickly and efficiently.
- **Keep the project free and open-source** for everyone.

#### **How You Can Help** 🙌

- ⭐ **Star this repo** to show your appreciation!
- 💬 **Share Vue Cal** with your network.
- 💵 **[Become a Sponsor](https://github.com/sponsors/antoniandre)** to keep Vue Cal thriving.

Every contribution—big or small—makes a huge difference. Join us on this journey and be part of something amazing! 💖

---

### ❤️ Special Thanks to Our Sponsors

A huge shoutout to our amazing sponsors who make Vue Cal possible. Want to see your name here? [Become a sponsor today!](https://github.com/sponsors/antoniandre)

<a href="https://github.com/nmauersberg"><img src="https://avatars.githubusercontent.com/nmauersberg?s=25" alt="nmauersberg" width="25"></a>
<a href="https://github.com/audabas"><img src="https://avatars.githubusercontent.com/audabas?s=25" alt="audabas" width="25"></a>
<a href="https://github.com/crbast"><img src="https://avatars.githubusercontent.com/crbast?s=25" alt="crbast" width="25"></a>
<a href="https://github.com/codecov"><img src="https://avatars.githubusercontent.com/codecov?s=25" alt="codecov" width="25"></a>
<a href="https://github.com/zeidanbm"><img src="https://avatars.githubusercontent.com/zeidanbm?s=25" alt="zeidanbm" width="25"></a>
<a href="https://github.com/cesar-lizurey"><img src="https://avatars.githubusercontent.com/cesar-lizurey?s=25" alt="cesar-lizurey" width="25"></a>

---

## 🛠️ Contributing

We welcome all contributions through well tested PRs. Check out the [Contributing Guide](CONTRIBUTING.md) to get started.

---

## 📄 License

Vue Cal is licensed under the [MIT License](LICENSE).

---

### Let’s Build the Future of Scheduling Together! 🚀
**[Become a Sponsor](https://github.com/sponsors/antoniandre)** and join the Vue Cal community today!
